import collections
import hashlib
import subprocess

command_status = collections.namedtuple('command_status',
                                        'stdout stderr retcode')


class mcenv(object):
    def __init__(self, frame_size="480x640"):
        self.session = subprocess.Popen(['mcenv', '-f', frame_size], bufsize=1,
                                        shell=False, stdin=subprocess.PIPE,
                                        stdout=subprocess.PIPE,
                                        stderr=subprocess.PIPE)

    def command(self, cmd_stdin):
        self.stdin_md5 = hashlib.md5(cmd_stdin).hexdigest()
        self.session.stdin.write("%s\necho -e '%s\n'$?\necho -e '%s' 1>&2\n" %
                                 (cmd_stdin, self.stdin_md5, self.stdin_md5))

        command_stdout = ''
        while True:
            line = self.session.stdout.readline()
            if line.rstrip('\n') == self.stdin_md5:
                break
            else:
                command_stdout += line
        command_stdout = command_stdout.rstrip('\n')

        command_retcode = self.session.stdout.readline().rstrip('\n')

        command_stderr = ''
        while True:
            line = self.session.stderr.readline()
            if line.rstrip('\n') == self.stdin_md5:
                break
            else:
                command_stderr += line
        command_stderr = command_stderr.rstrip('\n')
        return command_status(stdout=command_stdout, stderr=command_stderr,
                              retcode=command_retcode)

    def __getattr__(self, attrname):
        def method(args=''):
            return self.command('%s.k %s' % (attrname, args))
        return method
